
header {* GCM Component  Cplist lemmas *}


theory CpList imports CorrectComponent
begin


(*------------------------------------------------------------------------------------*)

subsection{*lemmas on cpSets and lists*}

lemma cplistsetEmpty[simp]: "cpListset [] = {}"
apply (simp add: cpListset_def);
done;

lemma cplistsetCons[simp]: "cpListset (C#CL) = cpSet C \<union> cpListset CL"
apply (simp add: cpListset_def cpSet_def);
done;

lemma cpSetAndList: "C'\<in> cpSet C = (\<exists> i<length (cpList C). ((cpList C)!i=C'))"
apply (unfold cpSet_def);
apply (simp add: in_set_conv_nth);
done;


lemma cpListFirst[simp]: "(cpList C)!0=C"
apply (case_tac C);
apply auto;
done;

lemma cpSetFirst[intro]: "C\<in> (cpSet C)"
apply (unfold cpSet_def);
apply (case_tac C,auto);
done;

lemma cpSetPrimitive[simp]: "cpSet (Primitive N i s) = {Primitive N i s}"
apply (unfold cpSet_def);
apply auto;
done;

lemma lengthlistlist_lb: "length CL\<le>length (cpListlist CL)"
apply (induct_tac CL)
apply simp+;
apply (case_tac a);
apply auto;
done;

lemma lengthlistlist: "length (cpListlist CL) = listsum (map length (map cpList CL))"
apply (induct_tac CL)
apply simp+;
done;

lemma appendlistlist: "cpListlist (CL@CL') = (cpListlist CL)@(cpListlist CL')"
apply (induct_tac CL);
apply auto;
done;

lemma cpListsetAppend: "cpListset (CL@CL') = (cpListset CL)\<union>(cpListset CL')"
apply (induct_tac CL);
apply (unfold cpListset_def);
apply auto;
done;


lemma cpListset_Un: "cpListset CL = {C. \<exists> C'\<in>set CL. C\<in>cpSet C' }"
apply (induct_tac CL);
apply (auto simp: cpListset_def cpSet_def);
done;

lemma cpSetcomposite[simp]: 
"cpSet (Composite N i sub b s) = {Composite N i sub b s} \<union> cpListset sub "
apply (induct_tac sub);
apply (auto simp: cpListset_def cpSet_def);
done;


lemma cpSetcomposite_set: 
"cpSet (Composite N i sub b s) = {Composite N i sub b s} \<union>{C.\<exists> C'\<in> set sub. C\<in>cpSet C'} "
apply (induct_tac sub);
apply (auto simp: cpSet_def);
apply (insert cpListset_Un)
apply (drule_tac x=list in meta_spec);
apply (auto simp: cpListset_def cpSet_def);
done;

lemma cpSetcomposite_rev: 
" \<lbrakk>C\<in> set sub; C'\<in>cpSet C \<rbrakk>\<Longrightarrow> C'\<in>cpSet (Composite N i sub b s)"
apply (auto simp: cpListset_Un);
done;

lemma cpSetcpSet[rule_format]: " \<forall> C'. (C''\<in> cpSet C' \<longrightarrow> C'\<in>cpSet C \<longrightarrow> C''\<in>cpSet C)"
apply (rule induct_Comp);
apply (auto simp: cpListset_Un);
done;

lemma cpListnonEmpty: "(cpList C)\<noteq>[]"
apply (case_tac C);
apply auto;
done;

lemma lengthcpListPrim[simp]: "(length (cpList (Primitive N itfs s)))=1"
apply auto;
done;

lemma cpSet_nonEmpty[intro]: "(cpSet C)\<noteq>{}"
apply (case_tac C);
apply auto;
done;

lemma cpListset_cpSet[rule_format,intro]: "C\<in> cpListset CL \<longrightarrow> (\<exists> C'\<in>set CL. C\<in>cpSet C')"
apply (induct_tac CL);
apply (auto simp: cpSet_def cpListset_def);
done;

lemma cpListcpListlist_rec: "C'\<in>set CL\<and> C\<in>cpSet C'\<longrightarrow>C\<in> set (cpListlist CL)"
apply (induct_tac CL);
apply (auto simp: cpSet_def);
done;
lemma setcpSet_cpListset[intro]: "\<lbrakk>C'\<in>set CL; C\<in>cpSet C'\<rbrakk>\<Longrightarrow>C\<in> cpListset CL"
apply  (insert cpListcpListlist_rec)
apply (auto simp: cpListset_def);
done;


lemma listlist_nth[rule_format]: " \<forall> n<length CL. (\<exists> i< length (cpListlist CL). CL!n  = (cpListlist CL) !i)"
apply (insert cpListset_Un[of CL]);
apply (auto);
apply (subgoal_tac "CL!n \<in>(cpListset CL)");
apply (auto simp: cpListset_def set_conv_nth)
done
(*FORMATTED:  ?n < length ?CL \<Longrightarrow>
    \<exists>i<length (cpListlist ?CL). ?CL ! ?n = cpListlist ?CL ! i *)

lemma CL_sub_CpList[rule_format]: "set CL \<subseteq> cpListset CL"
apply (induct_tac CL);
apply (auto);
done;

lemma CL_to_list: "C\<in>set CL \<Longrightarrow> C\<in>cpListset CL"
apply (insert CL_sub_CpList);
apply auto;
done;

lemma cpset_finite: "finite (cpSet C)"
apply (simp add: cpSet_def)
done;
(* SubComponent_SmallerCpset *)

lemma SubComponent_SmallerCpset[rule_format]: " \<forall> C\<in>cpSet C'. cpSet C \<subseteq> cpSet C'"
apply (rule induct_Comp);
apply (auto simp: cpListset_Un);
done;

lemma cp_nonRec_pre: " \<forall> sub N i b s. C\<in> cpListset sub \<longrightarrow>(Composite N i (sub) b s)\<notin> cpSet C"
apply (rule induct_Comp);
apply force;
apply auto;
apply (drule cpListset_cpSet);
apply clarify;
apply (drule_tac x=C' in bspec);
apply auto;
apply (drule_tac x=cplist in spec);
apply (auto  simp: cpListset_Un);
(*1*)
apply (drule_tac x=C'a in bspec);
apply (auto);
apply (drule_tac x=cplist in spec);
apply auto;
apply (drule_tac x=N in spec);
apply (drule_tac x=itfs in spec);
apply (drule_tac x=bindings in spec);
apply (drule_tac x=s in spec);
apply (rotate_tac-1,erule contrapos_np)
apply (rule_tac C'= "Composite Na i sub b sa" in cpSetcpSet);
(*1*)
apply auto;
done;

lemma cp_nonRec: " (Composite N i (sub) b s)\<notin> cpListset sub"
apply (insert cp_nonRec_pre);
apply auto;
apply (drule_tac x="Composite N i sub b s" in meta_spec);
apply (drule_tac x=sub in spec);
apply auto;
done;

(* SubComponent_SmallerCpList *)
lemma SubComponent_SmallerCpList[rule_format]: " \<forall> C\<in>cpSet C'.(length (cpList C))\<le>length (cpList C')"
apply (rule induct_Comp);
apply (auto simp: cpListset_Un);
(*1*)
apply (drule_tac x=C' in bspec);
apply simp;
apply (drule_tac x=C in bspec);
apply simp+;
apply (simp add: in_set_conv_nth)
apply (subgoal_tac " \<forall> i<length cplist. length (cpList (cplist!i))\<le>length (cpListlist cplist)");
apply force;
apply (induct_tac cplist)
(*2*)
apply simp+;
apply clarify;
apply (case_tac ia);
apply auto;
done;

lemma destinct_getNameListList[rule_format,intro]: 
"distinct (map getName (cpListlist CL)) \<longrightarrow> distinct (map getName  CL)"
apply (induct_tac CL);
apply auto;
apply (subgoal_tac " getName x\<in>getName ` set (cpListlist list)")
apply (subgoal_tac "getName a \<in> getName ` set (cpList a)");
apply force;
apply (subgoal_tac "a\<in>cpSet a");
apply (force simp: cpSet_def);
apply force;
apply (subgoal_tac "x\<in>cpListset list");
apply (force simp: cpListset_def);
apply force;
done;

(*------------------------------------------------------------------------------------*)
subsection{*getCp*}



lemma getCp_conv_nth[rule_format]: "(CL^N=Some C) \<longrightarrow> (\<exists> i<length CL. CL!i=C)"
apply (induct_tac CL);
apply simp;
apply clarify;
apply simp+;
apply (split split_if_asm)
apply (rule_tac x="0" in exI);
apply simp+; 
apply (erule exE);
apply (rule_tac x="Suc i" in exI);
apply simp;
done;
(* FORMATTED: ?CL ^ ?N = Some ?C \<Longrightarrow> \<exists>i<length ?CL. ?CL ! i = ?C*)


lemma nth_getCp[rule_format]: " CorrectComponentWeakList CL \<longrightarrow> (\<forall> i<length CL. CL^(getName (CL!i))=Some (CL!i))"
apply (induct_tac CL);
apply simp;
apply clarify;
apply (case_tac i)
apply simp;
apply (unfold CorrectComponentWeakList_def);
apply auto;
apply (thin_tac "set (RqIdList a) \<inter> set (RqIdListList list) = {}")
apply (simp add: Set.disjoint_iff_not_equal)
apply (fold cpSet_def)
apply (drule_tac x=a in bspec);
apply blast;
apply (rotate_tac -1)
apply (drule_tac x="list!nat" in bspec);
apply (simp add: set_conv_nth);
apply (drule listlist_nth);
apply auto;
done;
(* formatted  nth_getCp:
    \<lbrakk>CorrectComponentWeakList ?CL; ?i < length ?CL\<rbrakk>
    \<Longrightarrow> ?CL ^ getName (?CL ! ?i) = Some (?CL ! ?i) *)

lemma getCp_inlist[rule_format]: "CL^N = Some C \<longrightarrow> (C \<in> set  CL \<and> getName C = N)"
apply (induct_tac CL)
apply auto;
done;
(* FORMATTED ?CL ^ ?N = Some ?C \<Longrightarrow> ?C \<in> set ?CL \<and> getName ?C = ?N *)

lemma getCp_inlist2[intro]: "CL^N = Some C \<Longrightarrow> C \<in> set  CL"
by (auto simp: getCp_inlist)

lemma name_getCp[rule_format]: "\<lbrakk>CorrectComponentWeakList CL;i<length CL; CL!i=C;getName C = N\<rbrakk> \<Longrightarrow>(CL^N=Some C)"
apply (insert nth_getCp);
apply force;
done;

lemma getCp_None[rule_format]: "(CL^N=None) \<longrightarrow> (\<forall> i<length CL. getName (CL!i)\<noteq>N)"
apply (induct_tac CL);
apply simp;
apply clarify;
apply simp+;
apply (split split_if_asm)
apply simp+; 
apply (case_tac i)
apply auto;
done;
(*FORMATTED: \<lbrakk>?CL ^ ?N = None; ?i < length ?CL\<rbrakk> \<Longrightarrow> getName (?CL ! ?i) \<noteq> ?N*)

lemma getCp_name[rule_format]: "(CL^N=Some C) \<longrightarrow> getName C = N"
apply (induct_tac CL);
apply auto;
done;
(*FORMATTED getCp_name: ?CpList ^ ?N = Some ?C \<Longrightarrow> getName ?C = ?N *)

lemma getCpIdistinct[rule_format]: "distinct (map getName CL)\<longrightarrow>getName C = N\<longrightarrow> C\<in>set CL\<longrightarrow>CL^N=Some C"
apply (induct_tac CL);
apply auto;
apply (drule getCp_name);
apply simp+;
apply (subgoal_tac "getName C \<in> getName ` set list");
apply simp;
apply (rotate_tac 2);
apply (rule_tac x=C in rev_image_eqI);
apply simp+;
done;
(*FORMATTED  \<lbrakk>distinct (map getName ?CL); getName ?C = ?N; ?C \<in> set ?CL\<rbrakk> \<Longrightarrow> ?CL ^ ?N = Some ?C*)

lemma getCpI[rule_format]: "CorrectComponentWeakList CL\<longrightarrow>getName C = N\<longrightarrow> C\<in>set CL\<longrightarrow>CL^N=Some C"
apply (induct_tac CL);
apply simp+;
apply auto;
apply (subgoal_tac "getName a \<in>  getName ` (cpSet a)")
apply (subgoal_tac "getName a \<in>  getName ` (cpListset list)")
apply (force simp: cpSet_def);
apply (drule CL_to_list)
apply (auto simp: cpListset_def)+;
done;
(*FORMATTED \<lbrakk>CorrectComponentWeakList ?CL; getName ?C = ?N; ?C \<in> set ?CL\<rbrakk> \<Longrightarrow> ?CL ^ ?N = Some ?C*)

lemma getCpI2[rule_format]: "getName C = N\<longrightarrow> C\<in>set CL\<longrightarrow> (\<exists> C'. CL^N=Some C')"
apply (induct_tac CL);
apply auto;
done;
(*FORMATTED \<lbrakk>getName ?C = ?N; ?C \<in> set ?CL\<rbrakk> \<Longrightarrow> \<exists>C'. ?CL ^ ?N = Some C'*)

lemma getCp_cpSet[rule_format,intro]: " \<forall> C. CL^N=Some C \<longrightarrow> cpSet C \<subseteq>cpListset CL"
apply (induct_tac CL);
apply auto;
done;


lemma getCp_NoneI[rule_format,intro]:
"N\<notin>getName`(set CL)\<longrightarrow>CL^N=None"
apply (induct_tac CL);
apply auto;
done;

subsection{*getCp and remove1*}

lemma getCp_None_remove1[rule_format]: "CL^N=None \<longrightarrow> (remove1 C CL)^N=None"
apply (induct_tac CL);
apply auto;
done;

lemma remove_getCp_diff[rule_format,simp]:
" getName C'\<noteq>N\<longrightarrow>(remove1 C' sub)^N = sub^N"
apply (induct_tac sub);
apply auto;
done;

lemma remove_getCp_None[rule_format]:
" C'\<in> set sub \<longrightarrow>distinct (map getName sub)\<longrightarrow>(remove1 C' sub)^(getName C') = None"
apply (induct_tac sub);
apply simp;
apply clarify;
apply (case_tac "a=C'");
apply auto;
done;


(*------------------------------------------------------------------------------------*)
subsection{*cp list update *}

lemma upd_SameName[rule_format]: 
  " \<forall> N C. CL^N\<noteq>None\<longrightarrow>getName C = N\<longrightarrow> (CL<-C)^N=Some C"
apply (induct_tac CL);
apply auto;
done;
(* FORMATTED :  \<lbrakk>?CL ^ ?N \<noteq> None; getName ?C = ?N\<rbrakk> \<Longrightarrow> (?CL <- ?C) ^ ?N = Some ?C *)


lemma upd_names_eq[rule_format]: "CL^getName c2=Some c1\<longrightarrow>getName`cpSet c2 = getName`cpSet c1\<longrightarrow> getName` cpListset CL = getName ` cpListset (CL<-c2)"
apply (induct_tac CL);
apply auto;
done;
(* FORMATTED:         \<lbrakk>?CL ^ getName ?c2.0 = Some ?c1.0; getName ` cpSet ?c2.0 = getName ` cpSet ?c1.0\<rbrakk>
        \<Longrightarrow> getName ` cpListset ?CL = getName ` cpListset (?CL <- ?c2.0) *)

lemma upd_inlist[rule_format]: "CL^N \<noteq> None \<longrightarrow> getName C = N \<longrightarrow> C' \<in>cpSet C \<longrightarrow> C' \<in> cpListset (CL<-C)"
apply (induct_tac CL);
apply auto;
done;

(*FORMATED  upd_inlist:
    \<lbrakk>?CL ^ ?N \<noteq> None; getName ?C = ?N; ?C' \<in> set (cpList ?C)\<rbrakk>
    \<Longrightarrow> ?C' \<in> (cpListset (?CL <- ?C))*) 

lemma upd_diff[rule_format,intro]: "C'\<in> set CL \<longrightarrow>  getName C \<noteq> getName C' \<longrightarrow> C' \<in> set (CL<-C)"
apply (induct_tac CL);
apply simp;
apply clarify;
apply simp+;
apply (case_tac "C'=a");
apply simp+;
done;

lemma upd_diff_nth[rule_format,intro]: " \<forall>i.(i<length CL\<longrightarrow>getName C \<noteq> getName (CL!i) \<longrightarrow> (CL<-C)!i = CL!i)"
apply (induct_tac CL);
apply simp;
apply clarify;
apply simp+;
apply (case_tac i);
apply simp+;
done;

lemma upd_setCp[rule_format]: " \<forall> C C'. C\<in>cpListset (CL<-C')\<longrightarrow> (C\<in>(cpListset CL) \<or>C\<in>cpSet C')"
apply (induct_tac CL);
apply (auto simp: cpSet_def);
done;

lemma upd_setCpSimple[rule_format]: " \<forall> C C'. C\<in> set (CL<-C')\<longrightarrow> (C\<in>(set CL) \<or>C=C')"
apply (induct_tac CL);
apply (auto simp: cpSet_def);
done;

lemma upd_setCpI1[rule_format, intro]: "\<forall> C C'. CL^(getName C')=Some C\<longrightarrow> C'\<in>set (CL<-C')"
apply (induct_tac CL);
apply (auto);
done;

(*lemma upd_setCpI2[rule_format, intro]: "\<forall> C C'. getName C'\<noteq>getName C\<longrightarrow> (C\<in>set (CL<-C')) = (C\<in>set CL)"
apply (induct_tac CL);
apply (auto);
done;
*)

lemma upd_getCpunchanged[rule_format, intro]: "\<forall> C C'. N\<noteq>getName C'\<longrightarrow>((CL<-C')^N) = (CL^N)"
apply (induct_tac CL);
apply (auto);
done;

lemma upd_getUpdated[rule_format, intro]: "\<forall> C' C. (CL^(getName C')=Some C) \<longrightarrow>((CL<-C')^(getName C')) = Some C'"
apply (induct_tac CL);
apply (auto);
done;


lemma upd_inc[rule_format,intro]: "sub^getName C' = Some C0\<longrightarrow>C\<in>cpSet C' \<longrightarrow>C\<in>cpListset (sub<-C')"
apply (induct_tac sub);
apply auto;
done;


lemma upd_cpset[rule_format, intro]:
"CL^(getName C') = Some C \<longrightarrow> CorrectComponentWeakList CL \<longrightarrow>
cpListset (CL<-C') = (cpListset  CL)-(cpSet C)\<union> (cpSet  C')"
apply (induct_tac CL);
apply force;
apply clarify;
apply simp+;
apply rule;
apply clarify;
apply simp+;
apply blast;
apply clarify
apply (simp add: Un_Diff)+;
apply (subgoal_tac "cpSet  a \<inter> cpSet C = {}")
apply blast;
apply (subgoal_tac "cpSet  C \<subseteq> cpListset list");
apply force;
apply (rule getCp_cpSet);
apply simp;
done;

lemma upd_getCp_rev[rule_format, intro]: "C\<in>set(CL<-C')\<longrightarrow>(\<exists>C''. CL^(getName C)=Some C'')"
apply (induct_tac CL);
apply auto;
done;
(*---------------------------------------------------------------------------*)
subsection{*getRecsubCp*}

lemma getRecSubCp_Some_pre1:
 "((C^^N = Some C')  \<longrightarrow> C'\<in> cpSet C) \<and> (getRecSubCpList CL N = Some C' \<longrightarrow> C'\<in> cpListset CL)"
apply (induct_tac C and CL);
apply (auto simp: cpListset_Un);
(*1*)
apply (case_tac "Component ^^ N");
apply (auto);
done;

lemma getRecSubCp_Some_pre1_Cp:
 "(C^^N = Some C')  \<Longrightarrow> C'\<in> cpSet C"
apply (insert getRecSubCp_Some_pre1); apply auto;
done;

lemma getRecSubCp_Some_pre1_list:
 "getRecSubCpList CL N = Some C' \<Longrightarrow> C'\<in> cpListset CL"
apply (insert getRecSubCp_Some_pre1); apply auto;
done;


lemma getRecSubCp_Some_pre2:
 "((C^^N = Some C')  \<longrightarrow> getName C'=N) \<and> (getRecSubCpList CL N = Some C' \<longrightarrow> getName C'=N)"
apply (induct_tac C and CL);
apply (auto simp: cpListset_Un);
(*1*)
apply (case_tac "Component ^^ N");
apply (auto);
done;


lemma getRecSubCp_Some_pre2_Cp:
 "C^^N = Some C' \<Longrightarrow> getName C'=N"
by (insert getRecSubCp_Some_pre2,auto);

lemma getRecSubCp_getName_pre:
 "(CorrectComponentWeak C \<longrightarrow>C'\<in> cpSet C \<longrightarrow> C^^(getName C') = Some C') \<and> 
(CorrectComponentWeakList CL \<longrightarrow>C'\<in> cpListset CL \<longrightarrow> (getRecSubCpList CL (getName C') = Some C' ))"
apply (induct_tac C and CL);
apply force;
apply clarify;
apply simp+;
apply (erule disjE);
apply simp+;
apply rule;
apply clarify;
apply (frule correctCompWeak_distinct_name);
apply simp+;
(*4*)
apply clarify;
apply (erule impE);
apply (fold cpListset_def);
apply (auto simp: CorrectComponentListComp);
(*1*)
apply (split option.split)+;
apply (frule correctCompWeakList_distinct_name);
apply (subgoal_tac "CorrectComponentWeak Component")
apply (subgoal_tac "CorrectComponentWeakList list")
apply simp+;
(*3*)
apply rule;
apply clarify;
apply (subgoal_tac "getName C' \<in> getName ` (cpSet Component)")
apply (subgoal_tac "getName C' \<in> getName ` (cpListset list)")
apply force;
apply simp+;
(*3*)
apply (frule  getRecSubCp_Some_pre2_Cp);
apply (drule  getRecSubCp_Some_pre1_Cp);
apply (rotate_tac -2, drule sym, force simp: cpSet_def);
apply (force simp: CorrectComponentWeakList_def);
apply (force simp: CorrectComponentWeakList_def CorrectComponentWeak_def);
done;

lemma getRecSubCp_getName:
 "\<lbrakk>CorrectComponentWeak C; C'\<in> cpSet C\<rbrakk> \<Longrightarrow> C^^(getName C') = Some C'"
by (insert getRecSubCp_getName_pre, auto);

lemma getRecSubCpList_getName:
 "\<lbrakk>CorrectComponentWeakList CL; C'\<in> cpListset CL\<rbrakk> \<Longrightarrow> getRecSubCpList CL (getName C') = Some C'"
by (insert getRecSubCp_getName_pre, auto);

lemma getRecSubCp_Some[rule_format]: 
 " CorrectComponentWeak C  \<longrightarrow> (\<forall> C'. (C^^N = Some C')  = (C'\<in> cpSet C\<and>getName C' = N))"
apply (rule induct_Comp);
apply auto;
apply (drule correctCompWeak_distinct_name);
apply (subgoal_tac "C' \<in>  set (cpListlist cplist)")
apply auto;
(*4*)
apply (fold cpListset_def)
apply force;
apply (insert getRecSubCp_Some_pre1[of C N]);
apply (drule_tac x=C' in meta_spec);
apply (drule_tac x=cplist in meta_spec);
apply auto;
apply (rule getRecSubCp_Some_pre2_Cp);
apply force;
  apply (insert getRecSubCp_getName_pre[of C]);
(*1*)
apply (rotate_tac -1,drule_tac x=C' in meta_spec);
apply (drule_tac x=cplist in meta_spec);
apply clarify;
apply (rotate_tac -1,erule impE);
apply (force simp: CorrectComponentWeakList_def CorrectComponentWeak_def);
apply auto;
done;

lemma getRecSubCpList_conv_nth[rule_format]: "(getRecSubCpList CL N = Some C')\<longrightarrow> (\<exists>i<length CL. (CL!i)^^N = Some C')"
apply (induct_tac CL)
apply auto;
apply (case_tac "a^^N");
apply auto;
done;

lemma getRecSubCpList_conv_nth_rev[rule_format]: " \<forall>i<length CL.  ((CL!i)^^N = Some C' \<longrightarrow>( \<exists> C. getRecSubCpList CL N = Some C))"
apply (induct_tac CL)
apply force;
apply clarify;
apply (case_tac i);
apply force;
apply (case_tac "a^^N");
apply auto;
done;

lemma getRecSubCpList_Some[rule_format]: 
 " CorrectComponentWeakList CL  \<longrightarrow> (getRecSubCpList CL N = Some C')  = (C'\<in> cpListset CL\<and>getName C' = N)"
apply (induct_tac CL);
apply simp+;
apply clarify;
apply (case_tac  "a ^^ N");
apply simp+;
apply (drule_tac N=N in  getRecSubCp_Some);
apply force;
apply simp+;
apply (frule_tac N=N and C'=C' in  getRecSubCp_Some);
apply (frule_tac N=N and C'=aa in  getRecSubCp_Some);
apply auto;
done;

lemma CorrectComp_getRecSubCpList_conv_nth_rev[rule_format]: " CorrectComponentWeakList CL  \<longrightarrow> (\<forall>i<length CL.  ((CL!i)^^N = Some C \<longrightarrow>( getRecSubCpList CL N = Some C)))"
apply (induct_tac CL)
apply force;
apply clarify;
apply (case_tac i);
apply force;
apply (case_tac "a^^N");
apply auto;
apply (drule_tac N=N and C'=aa in getRecSubCp_Some);
apply simp+;
apply (subgoal_tac "getRecSubCpList list N = Some C")
apply (drule_tac  N=N and C'=C in getRecSubCpList_Some);
apply auto;
done;

lemma CorrectComponentWeak_getRecSubCp: "\<lbrakk>CorrectComponentWeak C ; C^^N =Some C'\<rbrakk> \<Longrightarrow> \<forall> C''\<in>cpSet C. (getName C''=N \<longrightarrow>C''=C')"
apply clarify;
apply (drule getRecSubCp_getName);
apply auto;
done;


lemma  getRecSubCpList_upd[rule_format]: "
CorrectComponentWeakList sub\<longrightarrow> CorrectComponentWeakList (sub<-C')\<longrightarrow> 
sub^getName C'=Some C\<longrightarrow> C' ^^ snd f = Some Ca\<longrightarrow>
 getRecSubCpList (sub <- C') (snd f) = Some Ca"
apply (induct_tac sub);
apply simp;
apply clarify;
apply simp+;
apply clarify;
apply (elim impE);
apply auto;
apply (simp split: option.split);
apply auto;
apply (subgoal_tac "getName aa\<in> getName ` cpSet a")
apply (subgoal_tac "getName aa=snd f")
apply (subgoal_tac "getName Ca\<in> getName ` cpListset (list <- C')")
apply (subgoal_tac "getName Ca=snd f")
apply simp+;
apply force;
apply (subgoal_tac "CorrectComponentWeak C'");
apply (rotate_tac -1,drule getRecSubCp_Some);
apply auto;
apply (subgoal_tac "Ca\<in> cpListset (list <- C')")
apply force;
apply (subgoal_tac "CorrectComponentWeak C'");
apply (rotate_tac -1,drule_tac N="getName x" in getRecSubCp_Some);
apply auto;
apply (drule_tac N="snd f" and C'=aa in getRecSubCp_Some);
apply force;
apply (subgoal_tac "aa\<in> cpSet a");
apply force;
apply (drule_tac N="snd f" and C'=aa in getRecSubCp_Some);
apply force;
done;

lemma getRecSubCpList_existssubCp[rule_format]: "(getRecSubCpList CL N = Some C')\<longrightarrow> (\<exists>C\<in>set CL. C^^N=Some C')"
apply (induct_tac CL)
apply auto;
apply (case_tac "a^^N");
apply auto;
done;

(*----------------------------------------------------------------*)
subsection{*RqIdList*}
lemma lengthlistlist_Id: "length (RqIdListList CL) = listsum (map length (map RqIdList CL))"
apply (induct_tac CL)
apply simp+;
done;

lemma LocalRqIdList: " set (RqIdLocalList C) \<subseteq> set  (RqIdList C)"
apply (case_tac C);
apply auto;
done;

lemma cpSetRqId[rule_format]: "C'\<in> cpSet C\<longrightarrow> (set (RqIdList C')\<subseteq> set (RqIdList C))"
apply (rule induct_Comp)
apply auto;
apply (subgoal_tac "set (RqIdList C') \<subseteq> set (RqIdListList cplist)");
apply force;
apply (subgoal_tac " \<forall> CL C. C\<in>set CL \<longrightarrow>set (RqIdList C) \<subseteq> set (RqIdListList CL)");
apply (force simp: cpListset_Un);
apply (rule allI,induct_tac CL);
apply auto;
done;

lemma cpSetRqIdList[rule_format]: "C'\<in>set CL\<longrightarrow> C\<in>cpSet C'\<longrightarrow> (set (RqIdList C)\<subseteq> set (RqIdListList CL))"
apply (induct_tac CL);
apply (auto);
apply  (drule cpSetRqId);
apply auto;
done;

lemma getCp_RqIdList[rule_format]: " \<forall> C. CL^N=Some C \<longrightarrow> set (RqIdList C) \<subseteq> set (RqIdListList CL)"
apply (induct_tac CL);
apply auto;
done;

lemma upd_RqIdList[rule_format, intro]:
"CL^(getName C') = Some C \<longrightarrow> CorrectComponentWeakList CL \<longrightarrow>
set (RqIdListList (CL<-C')) = (set (RqIdListList CL)-set (RqIdList C))\<union> set (RqIdList C')"
apply (induct_tac CL);
apply force;
apply clarify;
apply simp+;
apply rule;
apply clarify;
apply simp+;
apply blast;
apply clarify
apply (simp add: Un_Diff)+;
apply (subgoal_tac "set (RqIdList a) \<inter> set (RqIdList C) = {}")
apply blast;
apply (subgoal_tac "set (RqIdList C) \<subseteq>set (RqIdListList list)");
apply blast;
apply (rule getCp_RqIdList);
apply simp;
done;


(*--------------------------------------------------------------------*)
subsection{*lemmas involving CorrectComponentWeak*}

lemma CorrectComponentWeak_same_name_eq:
"\<lbrakk>CorrectComponentWeak (Composite N i sub b s);  (Composite N i' sub' b' s')\<in>cpSet (Composite N i sub b s)\<rbrakk> \<Longrightarrow> i=i' \<and> sub=sub' \<and> b=b' \<and> s=s'"
apply (drule correctCompWeak_distinct_name);
apply simp+;
apply (erule disjE);
apply force;
apply clarify;
apply (subgoal_tac  "(Composite N i' sub' b' s') \<in> set (cpListlist sub)");
apply (fold cpListset_def);
apply (auto simp: image_def);
done;


(* CorrectComponentWeak_distinctLocalRqIds *)
lemma CorrectComponentWeak_distinctLocalRqIds: "CorrectComponentWeak C' \<Longrightarrow> distinct (RqIdLocalList C')"
apply (case_tac C');
apply (unfold CorrectComponentWeak_def)
apply (auto simp: List.distinct_conv_nth);
apply (subgoal_tac "j<length (CcomputedResults CompState_ext_type) + (length (Cqueue CompState_ext_type))");
apply (subgoal_tac "i<length (CcomputedResults CompState_ext_type) + (length (Cqueue CompState_ext_type))");
apply (rotate_tac 3)
apply (drule_tac x=i in spec);
apply simp;
apply (rotate_tac -1)
apply (drule_tac x=j in spec);
apply (simp add: nth_append)+;
apply (case_tac "j<length (CcomputedResults CompState_ext_type)" )
apply simp+;
apply (case_tac "i < length (CcomputedResults CompState_ext_type)");
apply simp+;
apply (simp add: nth_append)+;
apply (subgoal_tac "i - length (CcomputedResults CompState_ext_type) < length (Cqueue CompState_ext_type)");
apply force;
apply arith;
apply (subgoal_tac "j - length (CcomputedResults CompState_ext_type) < length (Cqueue CompState_ext_type)");
apply (case_tac "i < length (CcomputedResults CompState_ext_type)");
apply simp+;
apply (simp add: nth_append)+;
apply (subgoal_tac "i - length (CcomputedResults CompState_ext_type) < length (Cqueue CompState_ext_type)");
apply auto;
done;


(* SubComponent_CorrectComponentWeak_pre *)
lemma SubComponent_CorrectComponentWeak_pre: " \<forall> C'\<in> cpSet C. (CorrectComponentWeak C \<longrightarrow> CorrectComponentWeak C')"
apply (rule induct_Comp);
apply (auto simp: cpListset_Un);
apply (drule CorrectComponentListComp);
apply (drule CorrectComponentListComp_rev);
apply simp+;
done;

(* SubComponent_CorrectComponentWeak *)

lemma SubComponent_CorrectComponentWeak: " \<lbrakk>C'\<in> cpSet C; CorrectComponentWeak C\<rbrakk> \<Longrightarrow> CorrectComponentWeak C'"
apply (insert SubComponent_CorrectComponentWeak_pre[of C], auto)
done;



subsection{*back to correctcomponentweak*}

(*lemma Set_DiffUn:
"(A-C)\<union>B = ((A \<union> B) - C) \<union> (B-C)"*)

lemma CorrectComponentWeakList_getName[rule_format]:
"CorrectComponentWeakList CL \<longrightarrow>C \<in> set CL \<longrightarrow>getName ` (cpSet C) \<inter> (getName ` (cpListset CL -cpSet C)) = {}"
apply (induct_tac CL);
apply auto;
done;


lemma CorrectComponentWeakList_update[rule_format,intro]: 
"CL^(getName C') = Some C\<longrightarrow> CorrectComponentWeakList CL \<longrightarrow> CorrectComponentWeak C' \<longrightarrow>
(getName ` cpSet C' - getName ` cpSet C) \<inter>(getName ` cpListset CL)={}\<longrightarrow>
(set (RqIdList C') - set (RqIdList C)) \<inter>(set (RqIdListList CL))={}
\<longrightarrow>distinct (RqIdList C')
\<longrightarrow>CorrectComponentWeakList (CL<-C')"
apply (induct_tac CL);
apply force
apply clarify;
apply (case_tac "getName a = getName C'");
apply simp+;
apply (subgoal_tac "a=C");
apply clarify;
apply blast;
apply blast;
(*1*)
apply (erule impE, simp)+;
apply blast;
apply (erule impE, simp)+;
apply force;
(*1*)
apply (erule impE, simp)+;
apply (unfold CorrectComponentWeakList_def)
apply simp+;
apply rule;
apply (frule upd_RqIdList);
(*3*)
apply (unfold CorrectComponentWeakList_def)
apply simp+;
apply clarify;
apply (subgoal_tac " set (RqIdList C) \<subseteq>set (RqIdListList list)")
apply force;
apply (drule getCp_RqIdList);
apply force;
(*1*)
apply (fold cpSet_def cpListset_def);
apply clarify;
apply (frule upd_cpset);
apply (simp add: CorrectComponentWeakList_def)+;
apply (subgoal_tac " getName ` cpSet C \<subseteq>getName ` (cpListset list)")
apply (simp add: image_Un)+;
apply (subgoal_tac 
"getName ` (cpListset list - cpSet C) = getName ` (cpListset list) -  getName ` (cpSet C)");
apply simp+;
(*3*)
apply (subgoal_tac " (getName ` cpSet C')\<inter> (getName ` cpSet a)={}")
apply (simp add: Diff_Int_distrib Set.Int_Un_distrib);
apply force;
apply (subgoal_tac " (getName ` cpSet C) \<inter>(getName ` cpSet a)={}")
apply (simp add: Diff_Int_distrib2 Set.Int_Un_distrib);
apply force;
(*2*)
apply (subgoal_tac "CorrectComponentWeakList list");
apply (drule_tac C=C in CorrectComponentWeakList_getName);
apply (auto simp: CorrectComponentWeakList_def);
done





lemma CorrectComponentWeak_Composite: 
"CorrectComponentWeak (Composite N itf subCp bindings s) = (CorrectComponentWeakList subCp 
\<and> N\<notin> getName ` (cpListset subCp)
\<and> (\<forall> b\<in> bindings.(GetQualified (src b) (Composite N itf subCp bindings s) =Some\<lparr>kind=Client,cardinality=Single\<rparr>)
      \<and> (GetQualified (dest b) (Composite N itf subCp bindings s)=Some\<lparr>kind=Server,cardinality=Single\<rparr>))
\<and> NoDuplicateSrc bindings
\<and> (\<forall>Q\<in>set (Cqueue s). (invokedItf Q)\<in> dom itf \<and> kind (the (itf (invokedItf Q))) = Server)
\<and> (distinct ((map fid (CcomputedResults s))@(map Request.id (Cqueue s))))
\<and> (( (fid ` set(CcomputedResults s))\<union>(id ` set(Cqueue s))) \<inter> (set (RqIdListList subCp)) = {}))"
apply (simp add: CorrectComponentWeakList_def CorrectComponentWeak_def CorrectComponentStructure_def CorrectComponentStructureList_def cpSet_def cpListset_def)+;
apply auto;
done;

end;