header {* Lemmas on Reduction of GCM Components *}

theory EagerHomeProperties imports GCMSemanticsEagerHome RqAndIds CorrectComponent begin


lemma comm_maintains_name: "S \<turnstile> c1 -[i1, i, v]\<rightarrow>\<^sub>O c2 \<Longrightarrow> getName c2 = getName c1"
apply (erule comm.cases);
apply auto;
done;

(*FORMATED   comm_maintains_name:
    ?S \<turnstile>?c1.0 -[?i1.0,?i,?v]\<rightarrow>\<^sub>O ?c2.0 \<Longrightarrow> getName ?c2.0 = getName ?c1.0 *)

lemma comm_maintains_name_rec: "S \<turnstile> c1 -[i1, i, v]\<rightarrow>\<^sub>O c2 \<Longrightarrow>  (\<forall> C . (cpList c1)^N = Some C \<longrightarrow> (\<exists> C' . (cpList c2)^N = Some C'))"
apply (erule comm.induct);
apply auto;
done;

(*FORMATED  comm_maintains_name_rec:
    ?S \<turnstile>?c1.0 -[?i1.0,?i,?v]\<rightarrow>\<^sub>O ?c2.0,?RL  \<Longrightarrow>
    \<forall>C. cpList ?c1.0 ^ ?N = Some C \<longrightarrow> (\<exists>C'. cpList ?c2.0 ^ ?N = Some C') *)


lemma red_maintains_name: "S \<turnstile> c1 \<rightarrow>\<^sub>R c2, RL \<Longrightarrow> getName c2 = getName c1"
apply (erule red.cases);
apply auto;
done;
(*FORMATED  red_maintains_name:
    ?S \<turnstile> ?c1.0 \<rightarrow>\<^sub>R ?c2.0,?RL \<Longrightarrow> getName ?c2.0 = getName ?c1.0  *)


lemma  comm_names_eq[rule_format]: "S \<turnstile> c1 -[i1, i, v]\<rightarrow>\<^sub>O c2 \<Longrightarrow>CorrectComponentWeak c1 \<longrightarrow> getName ` (cpSet c2)=getName ` (cpSet c1)"
apply (erule comm.induct);
apply auto;
done;



lemma red_names_eq[rule_format]: "S \<turnstile> c1 \<rightarrow>\<^sub>R c2,RL \<Longrightarrow>CorrectComponentWeak c1 \<longrightarrow> getName ` (cpSet c2)=getName ` (cpSet c1)"
apply (erule red.induct);
apply force;
apply force;
apply force;
(*4 hierarchy*)
apply clarify;
apply (elim impE);
apply (drule getCp_inlist);
apply clarify;
apply (drule CorrectComponentListComp)
apply (rule CorrectComponentListComp_rev);
apply force;
(*5*)
apply simp+;
apply (subgoal_tac "subCp ^ (getName c2) = Some C");
apply (drule upd_names_eq);
apply simp+;
apply (force simp: getCp_inlist red_maintains_name);

(*3 comm borthers *)
apply (intro allI impI)
apply simp+;
apply (subgoal_tac "getName ` cpListset (subCp') = getName ` cpListset subCp")
apply simp+;
apply (subgoal_tac "subCp' ^ (getName (C'\<leftarrow>\<lparr>Request.id = f, parameter = v, invokedItf = i2\<rparr>)) = Some C'");
apply (drule upd_names_eq);
apply (case_tac C');apply simp+;
apply (force simp: getCp_inlist);
(*3*)
apply (subgoal_tac "subCp ^ (getName c2) = Some C");
apply (drule upd_names_eq);
apply (rule comm_names_eq);
apply simp+;
apply (drule CorrectComponentListComp)
apply (rule CorrectComponentListComp_rev);
apply force;
(*5*)
apply (force simp: getCp_inlist);
apply simp+;
apply (force simp: getCp_inlist comm_maintains_name);
(*2 commparent *)
apply (intro allI impI)
apply simp+;
apply (subgoal_tac "getName ` cpListset (subCp<-c2) = getName ` cpListset subCp")
apply simp+;
apply (subgoal_tac "subCp ^ (getName c2) = Some C");
apply (drule upd_names_eq);
apply (rule comm_names_eq);
apply simp+;
(*4*)
apply (drule CorrectComponentListComp)
apply (rule CorrectComponentListComp_rev);
apply force;
apply (force simp: getCp_inlist);
apply simp+;
apply (force simp: getCp_inlist comm_maintains_name);

(*1 comm child*)
apply (intro allI impI)
apply simp+;
apply (subgoal_tac "subCp^(getName (C'\<leftarrow>\<lparr>Request.id=f, parameter=parameter R, invokedItf = i2\<rparr>))=Some C'");
apply (drule upd_names_eq);
apply (case_tac C');apply simp+;
apply (force simp: getCp_inlist);
done;

lemma fut_maintains_name: "c1 -[f, v, N]\<rightarrow>\<^sub>F c2, RL \<Longrightarrow>  getName c2 = getName c1"
apply (erule Fut.cases);
apply auto;
done;

(*FORMATED  fut_maintains_name:
     ?c1.0 -[?f,?v,?N]\<rightarrow>\<^sub>F?c2.0,?RL  \<Longrightarrow> getName ?c2.0 = getName ?c1.0 *)


lemma Fut_maintains_name_rec: 
" c1 -[f, v, N]\<rightarrow>\<^sub>F c2, RL \<Longrightarrow> CorrectComponentWeak c1 \<longrightarrow>  (\<forall> C . c1^^N = Some C \<longrightarrow> (\<exists> C' . c2^^N = Some C'))"
apply (erule Fut.induct);
apply simp;
apply auto;
apply (subgoal_tac " \<exists> i<length subCp. \<exists> C'. (subCp!i)^^N'  = Some C'")
apply clarify;
apply (drule_tac x=i in spec);
apply simp+;
apply clarify;
apply (subgoal_tac "CorrectComponentWeak (subCp ! i)");
apply simp+;
apply clarify;
apply (rule getRecSubCpList_conv_nth_rev);
apply force;
apply force;
apply (drule CorrectComponentListComp)
apply (drule_tac x="subCp!i" in  CorrectComponentListComp_rev)
apply simp+;
apply (drule getRecSubCpList_conv_nth);
apply force;
done;

(*FORMATED  Fut_maintains_name_rec:
     ?c1.0 -[?f,?v,?N]\<rightarrow>\<^sub>F?c2.0,?RL  \<Longrightarrow>
    CorrectComponentWeak ?c1.0 \<longrightarrow>
    (\<forall>C. cpList ?c1.0 ^ ?N = Some C \<longrightarrow> (\<exists>C'. cpList ?c2.0 ^ ?N = Some C')) *)


lemma comm_maintains_itfs: 
"S \<turnstile>C -[i1,f,v]\<rightarrow>\<^sub>O C'    \<Longrightarrow> (getItfs C') N =  (getItfs C) N"
apply (erule comm.induct);
apply auto;
done;

lemma O_sameRqIdList:
"S \<turnstile> C -[i1,f,v]\<rightarrow>\<^sub>O C' \<Longrightarrow> (RqIdList C') = (RqIdList C)"
apply (erule_tac comm.cases);
apply simp+;

(*2 behaviour stuff *)
apply (subgoal_tac "  Rep_Behaviours (behaviour s)\<in> Behaviours");
apply (simp add: Behaviours_def);
apply (elim conjE);
 apply (rotate_tac 10);
 apply (drule_tac x="PintState s" in spec);
 apply (rotate_tac -1, drule_tac x=s2 in spec);
apply clarify;
apply (simp add: Behaviour_def);
apply (simp add: Rep_Behaviours);

(*1 composite *)
apply force;
done;


axioms Fut_maintains_WF: "S -[f, v, N]\<rightarrow>\<^sub>F S2  ,RL \<Longrightarrow> CorrectComponentWeak S \<longrightarrow>CorrectComponentWeak S2"



axioms comm_maintains_WF[rule_format]: "  S \<turnstile> C -[i1, i, v]\<rightarrow>\<^sub>O C'  \<Longrightarrow> CorrectComponentWeak C \<longrightarrow> CorrectComponentWeak C'"


 

axioms red_maintains_WF[rule_format]: "S\<turnstile> C \<rightarrow>\<^sub>R C',RL \<Longrightarrow> CorrectComponentWeak C \<longrightarrow> CorrectComponentWeak C'" 

axioms red_maintains_WF_Strong[rule_format]: "S\<turnstile> C \<rightarrow>\<^sub>R C',RL \<Longrightarrow> CorrectComponent C \<longrightarrow> CorrectComponent C'" 

axioms fut_maintains_WF_Strong[rule_format]: "   S -[f,v,N]\<rightarrow>\<^sub>FS2,RL  \<Longrightarrow> CorrectComponent C \<longrightarrow> CorrectComponent C'" 


end;
